Controllers/ProductosController.cs
using MySql.Data.MySqlClient;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using WebFBX.Clases;
using WebFBX.Models;

namespace WebFBX.Controllers
{
    public class ProductosController : Controller
    {
        Clase_Conexion conexion = new Clase_Conexion();
        ///*# sourceMappingURL=style.css.map */
        ///

        [HttpPost]
        public ActionResult CreaListaEspera(string telefono, string correo, string producto, string nombre, string nombrecliente)
        {
            int retorno = 0;
            string errormsj = "";
            try
            {
                string fechaactual = DateTime.Now.ToString("yyyy-MM-dd");
                conexion.conectar();
                string sql = "SELECT producto FROM listaespera WHERE telefono=@telefono AND producto=@producto AND fecha=@fechaactual limit 1";
                using (MySqlCommand cmd = new MySqlCommand(sql, conexion.con))
                {
                    cmd.Parameters.AddWithValue("@telefono", telefono);
                    cmd.Parameters.AddWithValue("@producto", producto);
                    cmd.Parameters.AddWithValue("@fechaactual", fechaactual);

                    using (MySqlDataReader d = cmd.ExecuteReader())
                    {
                        if (d.Read())
                        {
                            retorno = 2;
                        }
                        else
                        {

                        }
                    }
                }

                if (retorno == 0)
                {
                    sql = "INSERT listaespera ";
                    sql += "SET telefono = @telefono";
                    sql += ",correo = @correo ";
                    sql += ",producto = @producto ";
                    sql += ",nombreproducto = @nombreproducto ";
                    sql += ",nombrecliente = @nombrecliente ";
                    sql += ",fecha = @fecha ";
                    MySqlCommand datos = new MySqlCommand(sql, conexion.con);
                    datos.Parameters.Add(new MySqlParameter("@producto", producto));
                    datos.Parameters.Add(new MySqlParameter("@telefono", telefono));
                    datos.Parameters.Add(new MySqlParameter("@correo", correo));
                    datos.Parameters.Add(new MySqlParameter("@nombreproducto", nombre));
                    datos.Parameters.Add(new MySqlParameter("@nombrecliente", nombrecliente));
                    datos.Parameters.Add(new MySqlParameter("@fecha", fechaactual));
                    datos.ExecuteNonQuery();
                    retorno = 1;

                }
            }
            catch (Exception error)
            {
                //String rollback = "rollback";
                //MySqlCommand datos_rollback = new MySqlCommand(rollback, conexion.con);
                //datos_rollback.ExecuteScalar();
                errormsj = error.Message;
                retorno = -1;
            }
            finally
            {
                conexion.cerrar();
            }
            return Json(new { retornoJson = retorno, errorJson = errormsj }, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public ActionResult partialFoto(string codigo)
        {
            ViewData["codigo"] = codigo;
            return View();
        }
        [HttpPost]
        public ActionResult partialFotoModificar(string codigo)
        {
            ViewData["codigo"] = codigo;
            return View();
        }
        public JsonResult VaciarCarrito()
        {
            Session["carrito"] = null;
            Session["contador"] = 0;
            Session["codigo_descuento"] = null;
            return Json(1);
        }

        public JsonResult GuardaCarrito(List<ProductosModels> carrito, double contador)
        {
            Session["carrito"] = carrito;
            Session["contador"] = contador;
            return Json(1);
        }
        [HttpPost]
        public ActionResult obtieneCarritoGuardado()
        {
            var p = Session["contador"];
            List<ProductosModels> listadoCarritoGuardado = Session["carrito"] as List<ProductosModels>;
            return Json(new { listadoCarritoGuardado = listadoCarritoGuardado.ToList() }, JsonRequestBehavior.AllowGet);
        }

        public ActionResult GetFoto(int codigo)
        {
            try
            {
                conexion.conectar();
                string sql = "SELECT foto,formato AS extension FROM fotos WHERE producto=" + codigo + "  ORDER BY portada DESC limit 1";
                byte[] imagen = null;
                string extension = "";
                string nombre = "foto";
                using (MySqlCommand cmd = new MySqlCommand(sql, conexion.con))
                {
                    using (MySqlDataReader d = cmd.ExecuteReader())
                    {
                        if (d.Read())
                        {
                            imagen = (byte[])d["foto"];
                            extension = (string)d["extension"];
                            nombre = nombre + codigo.ToString() + "." + extension;
                        }
                        else
                        {
                            var folder = Server.MapPath("~/img/imagen_sin_foto.png");
                            string contentType = "image/png";
                            byte[] foto_blanco = System.IO.File.ReadAllBytes(folder);
                            //MySqlConnection.ClearAllPools();
                            return File(foto_blanco, contentType, "imagen.png");
                        }
                    }
                }
                conexion.cerrar();
                //return File(imagen, "image/jpeg");
                return File(imagen, "application/octet-stream", nombre);

            }
            catch (Exception ex)
            {
                string erro = ex.Message;
                return Json(ex);
            }
        }

        //public ActionResult NormaSeo()
        //{
        //    return View();
        //}

        public ActionResult DetalleProducto(string codp)
        {

            //            **************************************
            String sql;
            try
            {
                int idCodp = Int32.Parse(codp);
                String sqlWP;
                DataTable tablaSeo = new DataTable();
                sqlWP = "call ProductoSEO (" + codp + ", '', '')";
                conexion.conectarWP();
                MySqlDataAdapter datosWP = new MySqlDataAdapter(sqlWP, conexion.conWP);
                datosWP.Fill(tablaSeo);
                conexion.cerrarWP();
                if (tablaSeo.Rows.Count > 0)
                {
                    Response.Redirect(tablaSeo.Rows[0]["post_name"].ToString());
                    codp = null;
                }
                else
                {
                    sql = "SELECT Productos.codigo as SKU,Productos.nombre as Titulo,Productos.unidad,IFNULL(Productos.observaciones,'') AS Descripcion,Productos.pesogrs,";
                    sql += "Productos.precio,";
                    sql += "Productos.agotado,";
                    sql += "Productos.preciooferta,Productos.venceoferta,";
                    sql += "CASE ";
                    sql += "WHEN Productos.oferta=1 AND Productos.venceoferta >= NOW() THEN 1 ";
                    sql += "ELSE 0 ";
                    sql += "END ";
                    sql += "AS ofertavigente,";
                    sql += "(SELECT ruta  ";
                    sql += "FROM fotos ";
                    sql += "WHERE producto=Productos.codigo ORDER BY portada DESC limit 1) AS imagenURL,";
                    sql += "CAST(Productos.indcabezaesquelon AS SIGNED) AS indcabezaesquelon,";
                    sql += "CAST(Productos.presentacion AS SIGNED) AS presentacion,";
                    sql += "CAST(Productos.inddescripcion AS SIGNED) AS inddescripcion,";
                    sql += "Productos.costo,";
                    sql += "CASE ";
                    sql += "WHEN Productos.cantidaddesde=0 THEN 1 ";
                    sql += "ELSE Productos.cantidaddesde ";
                    sql += "END ";
                    sql += "AS cantidaddesde ";
                    sql += "FROM Productos ";
                    sql += "WHERE codigo=" +codp;

                    DataTable tablaSeo_0 = new DataTable();
                    DataTable tablaSeo_1 = new DataTable();
                    DataTable tablaSeo_listado = new DataTable();

                    conexion.conectar();
                    MySqlDataAdapter datosWP_0 = new MySqlDataAdapter(sql, conexion.con);
                    datosWP_0.Fill(tablaSeo_0);
                    conexion.cerrar();

                    foreach (DataRow fila_seo in tablaSeo_0.Rows)
                    {
                        string titulo = fila_seo["Titulo"].ToString();
                        string sku = fila_seo["SKU"].ToString();
                        string descripcion = fila_seo["descripcion"].ToString();
                        string imagen = fila_seo["imagenURL"].ToString().Replace("~", "https://www.fishboxchile.cl/");

                        sql = "SELECT  * FROM `wpwc_product_meta_lookup` WHERE sku='" + sku + "'";
                        conexion.conectarWP();
                        MySqlDataAdapter datosWP_listado = new MySqlDataAdapter(sql, conexion.conWP);
                        datosWP_listado.Fill(tablaSeo_listado);
                        if (tablaSeo_listado.Rows.Count == 0)
                        {
                            sql = "insert into wpposts(ping_status,";
                            sql += "post_author, post_title, post_type, ";
                            sql += "post_content, post_status, post_name) ";

Views/Productos/NormaSeo.cshtml
@model IEnumerable<WebFBX.Models.FotosModels>
@{
   
}


<div class="container_productos">
    <div class="form-group">
        <div class="row">
            <div class="col-lg-2">
            </div>
            <div class="col-lg-8 contener_catalogo_detalle">
                <br />
                <h2 id="titulo_catalogo"></h2>
                <div>
                    @*<input type="text" class="form-control" id="input_busqueda" placeholder="Buscar Familia de Productos...">
                        <button class="btn_delete bg-transparent btn-xs" id="limpiar_busqueda" style="margin-left: -40px; z-index: 100;">
                            <i class="fa fa-times"></i>
                        </button>
                        <button type="button" class="btn btn-primary" id="buscar"><i class="fas fa-search"></i></button>*@
                    <button type="button" class="btn btn-primary" style="background-color:transparent;border: #fff solid"><i class="fas fa-search"></i></button>
                    <button class="btn btn-danger float-right" type="button" id="vaciar_carrito" title="Vaciar Carrito">
                        <i class="fas fa-trash"></i>
                    </button>
                    <button class="btn btn-success float-right" type="button" id="ver_carrito" title="Ver Carrito">
                        <i class="fas fa-shopping-cart shopping-cart"></i><span id="cantidad_carrito">(0)</span>
                    </button>

                </div>
                <div id="Partial_ListadoProductos">


                    <div class="row">
                        <div class="col-lg-5">



                        </div>
                        <div class="col-lg-7">
      
                          

                          
                         

                                <div class="form-group">
                                    <div class="row">
                                        <div class="col-lg-5 col-5">
                                            <div class="input-group">
                                                <span class="input-group-btn">
                                                    <button type="button" class="btn btn-danger btn-number_detalle boton_celular" data-type="minus" data-field="quant[2]">
                                                        <span class="fas fa-minus"></span>
                                                    </button>
                                                </span>
                                                <input id="prodcantidad_detalle" type="text" name="quant[2]" class="form-control input-number_detalle text-center form-control-celular" value="1" min="1" onkeypress="return SoloNumerosDecimalesComa(event, '0,1', 9, 1)" max="999">


                                                <span class="input-group-btn">
                                                    <button type="button" class="btn btn-success btn-number_detalle boton_celular" data-type="plus" data-field="quant[2]">
                                                        <span class="fas fa-plus"></span>
                                                    </button>
                                                </span>
                                            </div>
                                        </div>
                                        <div class="col-lg-7 col-7">
                                            <div class="item">

                                                <button type="button" class="btn btn-primary btn-add_cart_detalle boton_celular" >
                                                    Añadir al Pedido
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                              
                            <br />
                        </div>
                    </div>


                </div>
            </div>
            <div class="col-lg-2">

            </div>
        </div>
    </div>
</div>

<div id="fb-root"></div>
<script async defer crossorigin="anonymous" src="https://connect.facebook.net/es_LA/sdk.js#xfbml=1&version=v8.0" nonce="uH0sEcVj"></script>


@section scripts{





    @Scripts.Render("~/bundles/spinner")
    @Scripts.Render("~/bundles/carrito")
}

Views/Productos/partialFoto.cshtml
@{
    Layout = null;
    int codigo = Convert.ToInt32(ViewData["codigo"]);
}


<img src="@Url.Action("GetFoto","Productos",new { codigo=codigo})" alt="" class="img-fluid" style="max-width:100px;" />

Views/Productos/partialFotoModificar.cshtml
@{
    Layout = null;
    int codigo = Convert.ToInt32(ViewData["codigo"]);
}


<img src="@Url.Action("GetFoto","Productos",new { codigo=codigo})" alt="" class="img-responsive_producto img-fluid" style="max-width:600px;max-height:200px"  />

Views/Productos/partialListadoProductosXfamilia.cshtml
@model IEnumerable<WebFBX.Models.ProductosModels>

@{
    Layout = null;
    int i = 0;
    int impar = 0;
    string f = ViewData["fila_padre"].ToString();
    string disponible = "";
    string nombre_producto = "";
}
<div class="items">
    @*<div class="row">*@
    @foreach (var item in Model)
    {
        i++;
        impar++;

        if (item.nombre.Length > 40)
        {
            nombre_producto = item.nombre.Substring(0, 40) + "...";
        }
        else
        {
            nombre_producto = item.nombre;
        }
        if (item.agotado == 0)
        {
            disponible = "Disponible";
        }
        else
        {
            disponible = "Agotado";

        }
        if (impar == 1)
        {
            <text><div class="row">
            </text>
        }
        <div class="col-md-4 quitabordes">
            <div class="card  border_panel ">
                <!--Card image-->
                <!--Card content-->
                <div class="card-body" style="padding:2px !important">
                    <!--Title-->
                    <div class="item altura_panel" style="position:relative;">
                        @if (item.agotado == 1)
                        {
                            <div class="card-title">
                                <div class="row">
                                    <div class="col-4 col-sm-3 col-md-12 order-2 order-md-1 col-md-12 quita_izquierda">
                                        <div class="container_foto text-center" style="background-color: #fff;">
                                            <img src="@Url.Content(item.rutafoto)" alt="" class="ancho_fotos_listado" />
                                            <div id="triangle-topleft-agotado">
                                                <div class="text-agotado">
                                                    Agotado
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-8 col-sm-9 col-md-12 order-1 order-md-2 nombre_titulo" id="nombre_titulo_@(f + i.ToString())">@nombre_producto</div>
                                </div>
                            </div>
                            <br class="hidden-xs hidden-sm" id="salto_linea_@(f + i.ToString())" style="display:none" />
                            <div class="botones" style="position:absolute;bottom:0 !important;">
                                <span style="font-weight:bold">$@item.precio.ToString("N0")<span class="stock_style" title="Disponible en Stock"> (@disponible)</span></span>
                                <br />
                                <button class="btn btn-success add-to-cart letra_btn_producto" type="button" data-nombre="@item.nombre" data-codigo="@item.codigo" data-unidad="@item.unidad" data-pesogrs="@item.pesogrs"
                                        data-precio="@item.precio.ToString("N0")" data-indpresentacion="@item.indpresentacion" data-indcabezaesquelon="@item.indcabezaesquelon" data-inddescripcion="@item.inddescripcion"
                                        data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible" data-costo="@item.costo">
                                    Agregar
                                </button>
                                <a href="#" class="btn btn-info ver_detalle_producto letra_btn_producto" data-nombre="@item.nombre" data-codigo="@item.codigo" data-costo="@item.costo"
                                   data-marca="@item.marca" data-precio="@item.precio.ToString("N0")" data-preciooriginal="@item.precio.ToString("N0")" data-preciooferta="@item.preciooferta" data-inddescripcion="@item.inddescripcion"
                                   data-ofertavigente="@item.ofertavigente" data-unidad="@item.unidad" data-pesogrs="@item.pesogrs" data-indpresentacion="@item.indpresentacion" data-indcabezaesquelon="@item.indcabezaesquelon"
                                   data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible" data-observacion="@item.observaciones">Ver Detalle</a>
                            </div>
                        }
                        else if (item.ofertavigente == 0)
                        {
                            <div class="card-title">
                                <div class="row">
                                    <div class="col-4 col-sm-3 col-md-12 order-2 order-md-1 col-md-12 quita_izquierda">
                                        <div class="container_foto text-center" style="background-color: #fff;">
                                            <img src="@Url.Content(item.rutafoto)" alt="" class="ancho_fotos_listado" />

                                        </div>
                                    </div>
                                    <div class="col-8 col-sm-9 col-md-12 order-1 order-md-2 nombre_titulo" id="nombre_titulo_@(f + i.ToString())">@nombre_producto</div>
                                </div>
                            </div>
                            <br class="hidden-xs hidden-sm" id="salto_linea_@(f + i.ToString())" style="display:none" />

                            <div class="botones" style="position:absolute;bottom:0 !important;">
                                <span style="font-weight:bold">$@item.precio.ToString("N0")<span class="stock_style" title="Disponible en Stock"> (@disponible)</span></span>
                                <br />
                                <button class="btn btn-success add-to-cart letra_btn_producto" type="button" data-nombre="@item.nombre" data-codigo="@item.codigo" data-unidad="@item.unidad" data-pesogrs="@item.pesogrs"
                                        data-precio="@item.precio.ToString("N0")" data-indpresentacion="@item.indpresentacion" data-indcabezaesquelon="@item.indcabezaesquelon" data-inddescripcion="@item.inddescripcion"
                                        data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible" data-costo="@item.costo">
                                    Agregar
                                </button>
                                <a href="#" class="btn btn-info ver_detalle_producto letra_btn_producto" data-nombre="@item.nombre" data-codigo="@item.codigo" data-costo="@item.costo"
                                   data-marca="@item.marca" data-precio="@item.precio.ToString("N0")" data-preciooriginal="@item.precio.ToString("N0")" data-preciooferta="@item.preciooferta" data-inddescripcion="@item.inddescripcion"
                                   data-ofertavigente="@item.ofertavigente" data-unidad="@item.unidad" data-pesogrs="@item.pesogrs" data-indpresentacion="@item.indpresentacion" data-indcabezaesquelon="@item.indcabezaesquelon"
                                   data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible" data-observacion="@item.observaciones">Ver Detalle</a>
                            </div>
                        }
                        else
                        {
                            <div class="card-title">
                                <div class="row">
                                    <div class="col-4 col-sm-3 col-md-12 order-2 order-md-1 col-md-12 quita_izquierda">
                                        <div class="container_foto text-center" style="background-color: #fff;">
                                            <img src="@Url.Content(item.rutafoto)" alt="" class="ancho_fotos_listado" />
                                            <div id="triangle-topleft">
                                                <div class="text-oferta">
                                                    Oferta
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-8 col-sm-9 col-md-12 order-1 order-md-2 nombre_titulo" id="nombre_titulo_@(f + i.ToString())">@nombre_producto</div>
                                </div>
                            </div>
                            <br class="hidden-xs hidden-sm" id="salto_linea_@(f + i.ToString())" style="display:none" />

                            <div class="botones" style="position:absolute;bottom:0 !important;">
                                <span class="precio_tachado">$@item.precio.ToString("N0")</span><span style="font-weight:bold"> $@item.preciooferta.ToString("N0")<span class="stock_style" title="Disponible en Stock"> (@disponible)</span></span>
                                <br />
                                <button class="btn btn-success add-to-cart letra_btn_producto" type="button" data-nombre="@item.nombre" data-codigo="@item.codigo"
                                        data-precio="@item.preciooferta.ToString("N0")" data-rutaimagen="@Url.Content(item.rutafoto)"
                                        data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible">
                                    Agregar
                                </button>
                                <a href="#" class="btn btn-info ver_detalle_producto letra_btn_producto" data-nombre="@item.nombre" data-codigo="@item.codigo"
                                   data-marca="@item.marca" data-precio="@item.preciooferta.ToString("N0")" data-preciooriginal="@item.precio.ToString("N0")" data-preciooferta="@item.preciooferta"
                                   data-rutaimagen="@Url.Content(item.rutafoto)" data-ofertavigente="@item.ofertavigente" data-unidad="@item.unidad" data-pesogrs="@item.pesogrs"
                                   data-agotado="@item.agotado" data-cantidaddesde="@item.cantidaddesde" data-disponible="@disponible" data-observacion="@item.observaciones">Ver Detalle</a>
                            </div>
                        }




                    </div>
                </div>
            </div>
        </div>
        if (impar == 3)
        {
            impar = 0;

            <text> <@("/")div>
            </text>

}

}
@if (i == 0)
{
    <div class="text-center"><b>No hay productos disponibles</b> </div>
}
</div>
<script>
    $(document).ready(function () {

        $('.ver_detalle_producto').on('click', function (e) {
            e.preventDefault();
            
            var nombre = $(this).data("nombre");
            var codigo = $(this).data("codigo");
            var precio = $(this).data("precio").toString().replace(/\./g, '').replace(',', '.');
            var agotado = $(this).data("agotado");
            var unidad = $(this).data("unidad");
            var pesogrs = $(this).data("pesogrs");
            var observacion = $(this).data("observacion");
            var preciooferta = $(this).data("preciooferta");
            var preciooriginal = $(this).data("preciooriginal").toString().replace(/\./g, '').replace(',', '.');
            var ofertavigente = $(this).data("ofertavigente");
            var inddescripcion = $(this).data("inddescripcion");
            var indpresentacion = $(this).data("indpresentacion");
            var indcabezaesquelon = $(this).data("indcabezaesquelon");
            var costo = $(this).data("costo");
            var cantidaddesde = $(this).data("cantidaddesde");

            $("#Partial_ListadoProductos").removeClass("scroll_vertical");
            var producto = {};
            producto.codigo = codigo;
            producto.nombre = nombre;
            producto.unidad = unidad;
            producto.pesogrs = pesogrs;
            producto.precio = parseFloat(precio);
            producto.agotado = agotado;
            producto.preciooferta = parseFloat(preciooferta);
            producto.preciooriginal = parseFloat(preciooriginal);
            producto.ofertavigente = ofertavigente;
            producto.inddescripcion = inddescripcion;
            producto.indpresentacion = indpresentacion;
            producto.indcabezaesquelon = indcabezaesquelon;
            producto.costo = costo;
            producto.cantidaddesde = cantidaddesde;
            producto.observaciones = observacion;
            guardarCarritoSession();
            window.location.href = "/Productos/DetalleProducto/?codp=" + codigo;
            @*$("#Partial_ListadoProductos").html(div_loader);

            $.ajax({
                type: "POST",
                url: '@Url.Action("partialDetalleProducto", "Productos")',
                data: JSON.stringify({
                    producto: producto,
                }),
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.retornoJson == -1) {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno. Indique a soporte la descripción del error: " + data.errorJson);
                    } else {
                        $("#Partial_ListadoProductos").html(data);
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de Conexión");

                }
            });*@
        });

    });



</script>